C ****** BEYE
      SUBROUTINE BEYE(DISTE)

C    TO CHECK INPERSP FOR POINTS BEHIND THE EYE
C    AND TO ADJUST THEM TO ALLOW INTERIOR VIEWS
C   DISTE IS DISTANCE FROM EYE TO FOCUS
C   THE X-COORD OF PROJECTED POINTS
C    IS LT -DISTE IF THE ORIGINAL POINT WAS
C    BEHIND THE EYE,RELATIVE TO FOCUS DIRECTION

#include "viewer.h2"

      BIG=1.0E6
      NE1=1

C DO EACH BODY IN TURN
C***D       WRITE(20,*)' BEHIND THE EYE'
      DO 20 I=1,NB
C***D       WRITE(20,*)' BODY',I
C   GET START AND FINISH EDGE NUMBERS
      IF(I.EQ.NB)GO TO 24
      NE2=IBE1(I+1)-1
      GO TO 25
  24  NE2=NR

C FIRST, DONT SHIFT BEHIND-EYE POINTS ATTACHED TO
C ALREADY SHIFTED POINTS
      KBB=0
      GO TO 25
C SECOND, AFTER ALL ELSE SHIFTED,DO THE ATTACHED POINTS
C   (BECAUSE THERE IS NO OTHER WAY TO MAKE THEM SHIFT
  23  KBB=1

C   SET NUMERS OF SHIFTED POINTS,EDGES BEHIND EYE,EDGES INFRONT EYE
C   AND POINTS BEHIND EYE ATTACHE TO ALREADY-SHIFTED POINTS
  25  IPS=0
      IBBE=0
      ICCE=0
      IBBP=0

C DO EACH EDGE OF THIS BODY
      DO 30 J=NE1,NE2
C GET POINTS OF THIS EDGE
      KS1=IREPU1(J)
      KS2=IREPU2(J)

C AND X COORDS OF THE POINTS
      X1=PUPRVI(KS1,1)
      X2=PUPRVI(KS2,1)

C CHECK IF EITHER POINT BEHIND EYE(X<0)
      JBE1=0
      JBE2=0
      IF(X1.LT.(-DISTE))JBE1=1
      IF(X2.LT.(-DISTE))JBE2=1

C BOTH IN FRONT
      IF(JBE1.EQ.0.AND.JBE2.EQ.0)GO TO 29
C 1 IN FRONT,2 BEHIND
      IF(JBE1.EQ.0.AND.JBE2.EQ.1)GO TO 41
C 1 BEHIND ,2 IN FRONT
      IF(JBE1.EQ.1.AND.JBE2.EQ.0)GO TO 40
C BOTH BEHIND,GO AND DO NOTHING
      IF(JBE1.EQ.1.AND.JBE2.EQ.1)GO TO 50

C REVERSE POINT FOR CONVENIENCE

C DONT SHIFT USING A SHIFTED POINT UNLESS THIS IS SECOND TIME THRO
  40  IF(KBB.EQ.0.AND.X2.GT.(0.5*BIG))GO TO 55
      KS=KS1
      KS1=KS2
      KS2=KS
      XS=X1
      X1=X2
      X2=XS
      GO TO 43

C 1FRONT 2BEHIND
C DONT SHIFT 2 IF 1 ALREADY SHIFTED
C UNLESS THIS IS SECOND TIME THRO
  41  IF(KBB.EQ.0.AND.X1.GT.(0.5*BIG))GO TO 55
C PROJECTED COORDS
  43  Y1=PUPRVI(KS1,2)
      Z1=PUPRVI(KS1,3)
      Y2=PUPRVI(KS2,2)
      Z2=PUPRVI(KS2,3)

C REPROJECT SO THAT
C POINT2 GOES TO 'INFINITY' AT 'BIG' XYZ
C BUT STAYS ON SAME LINE THRO X1Y1Z1 AND X2 Y2 Z2
C POINT 1 DOES NOT MOVE
      PUPRVI(KS2,1)=BIG+X2
      D=(Y1-Y2)/(X1-X2)
      PUPRVI(KS2,2)=BIG*D+Y2
      D=(Z1-Z2)/(X1-X2)
      PUPRVI(KS2,3)=BIG*D+Z2
C***D      WRITE(20,*)' EDGE',J,' POINTS',KS1,KS2
C***D      WRITE(20,*)' KS2 SHIFTED-',(PUPRVI(KS2,K),K=1,3)
C SET POINT2 NOW IN FRONT OF EYE:INCREMENT POINT S SHIFTED
      IPS=IPS+1
      GO TO 30
C INCREMENT EDGES BEHIND EYE
  50  IBBE=IBBE+1
      GO TO 30
C INCREMENT POINTS BEHIND ,ATTACHED TO SHIFTED POINT
  55  IBBP=IBBP+1
      GO TO 30
C INCREMENT EDGES INFRONT OF EYE
  29  ICCE=ICCE+1
C GET NEXT EDGE OF THIS BODY
  30  CONTINUE

C IF A POINT SHIFTED,RETURN TO TRY AGAIN WITH THIS BODY
      IF(IPS.GT.0)GO TO 25

C ALL SHIFTED EXCEPT POINTS BEHIND EYE ATTACHED TO ALREADY SHIFTED
C POINTS, NOW DO THEM IF ANY
       IF(IBBP.GT.0)GO TO 23
C IF ALL INFRONT,GO TO NEXT BODY
      IF(IBBE.EQ.0)GO TO 19
C OTHERWISE ALL BEHIND EYE
C SHIFT THIS BODY OFF TO INFINITY
C***D       WRITE(20,*)' SHIFTED TO INFINITY'
C GET START AND FINISH POINTS
      NP1=IBP1(I)
      IF(I.EQ.NB)GO TO 27
      NP2=IBP1(I+1)-1
      GO TO 28
  27  NP2=NP

C DO EACH PIINT OF THIS BODY
  28  DO 60 K=NP1,NP2
      PUPRVI(K,1)=BIG
      PUPRVI(K,2)=BIG
      PUPRVI(K,3)=BIG
  60  CONTINUE

C NEXT BODY.
  19  NE1=NE2+1
  20  CONTINUE

      RETURN
      END

C ****** BEYEPT
      SUBROUTINE BEYEPT(X2,Y2,Z2,X1,Y1,Z1)

C TO RE-PROJECT A POINT 2 WHICH IS BEHIND EYE
C WHERE OTHER END 1 IS IN FRONT OF EYE
C CALLED FROM PERS1,PERS2,HLR,HLR2 NOW THAT
C POINTS ARE NOT REPROJECTED IN BEYE,BEFORE THE VIEW IS ACLACULATED
C AND FROM TRANSF TO DO BOUND BOXES

C X2-X1 CANNOT BE ZERO, I THINK!
      DY=(Y2-Y1)/(X2-X1)
      DZ=(Z2-Z1)/(X2-X1)
      BIG=1.0E6
      DX=BIG-X2
      X2=BIG
      Y2=DX*DY+Y2
      Z2=DX*DZ+Z2
      RETURN
      END
